"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var _utils = require("./utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var operators = {
  '+': 'add',
  '*': 'mul',
  '-': 'sub',
  '/': 'div',
  '**': 'pow'
};

var _default = function _default(api) {
  return {
    visitor: {
      CallExpression: {
        exit: function exit(path) {
          var node = path.node;

          if (t.isIdentifier(node.callee) && node.callee.name === _utils.tf) {
            path.replaceWith(node.arguments[0]);
          }
        }
      },
      NumericLiteral: {
        enter: function enter(path) {
          if (!(0, _utils.shouldParse)(path)) return;
          var parent = path.parentPath.node;

          if (t.isCallExpression(parent) && t.isMemberExpression(parent.callee) && t.isIdentifier(parent.callee.object) && t.isIdentifier(parent.callee.property) && parent.callee.object.name == _utils.tf && parent.callee.property.name == 'scalar') {
            return;
          }

          path.replaceWith(t.callExpression(t.memberExpression(t.identifier(_utils.tf), t.identifier('scalar')), [t.numericLiteral(path.node.value)]));
        }
      },
      BinaryExpression: {
        enter: function enter(path) {
          if (!(0, _utils.shouldParse)(path)) return;
          var node = path.node;
          var tfmethod = operators[node.operator];

          if (tfmethod === undefined) {
            return;
          }

          path.replaceWith(t.callExpression(t.memberExpression(t.identifier(_utils.tf), t.identifier(tfmethod)), [t.cloneDeep(node.left), t.cloneDeep(node.right)]));
        }
      },
      ArrayExpression: {
        enter: function enter(path) {
          if (!(0, _utils.shouldParse)(path)) return;
          path.replaceWith(t.callExpression(t.memberExpression(t.identifier(_utils.tf), t.identifier('tensor')), [t.cloneDeep(path.node)]));
        }
      }
    }
  };
};

exports.default = _default;
module.exports = exports["default"];
//# sourceMappingURL=index.js.map